%define name		PowerDNS
%define version		2.9.13
%define release		1mdk

Summary:		PowerDNS is a Versatile Database Driven Nameserver
Name:			%{name}
Version:		%{version}
Release:		%{release}
License:		GPL
Group:			System/Servers
URL:			http://www.powerdns.com/
Source0:		pdns-%{version}.tar.bz2
Patch0:			pdns-2.9.7-init.patch.bz2
Patch1:			pdns-2.9.12-avoid-version.diff.bz2
Patch2:			pdns-2.9.13-libpq++_fix.diff.bz2

# wget -rm http://rtfm.powerdns.com
Source1:		rtfm.powerdns.com.tar.bz2

Source2:		powerdns-recursor.init.bz2

PreReq:			rpm-helper
BuildRequires:		MySQL-devel
BuildRequires:		bison
BuildRequires:		flex
BuildRequires:		gdbm-devel
BuildRequires:		libstdc++-devel
BuildRequires:		libtdb-devel
BuildRequires:		openldap-devel
BuildRequires:		openssl-devel
BuildRequires:		postgresql-devel
BuildRequires:		postgresql-libs-devel
BuildRequires:		pq++-devel
BuildRequires:		sqlite-devel
BuildRequires:		zlib-devel
#BuildRequires:		docbook-utils-pdf

BuildRoot:		%{_tmppath}/%{name}-%{version}-buildroot
Provides:		nameserver pdns powerdns
Obsoletes:		nameserver pdns powerdns
#Conflicts:		tmdns

%description
PowerDNS is a versatile nameserver which supports a large number
of different backends ranging from simple zonefiles to relational
databases and load balancing/failover algorithms.

This RPM is statically compiled and should work on all Linux distributions.
It comes with support for MySQL, PostgreSQL, Bind zonefiles and the 'pipe
backend' availible as external packages.

%package		recursor
Summary:		Recursor for %{name}
Group:			System/Servers
PreReq:			rpm-helper
Requires:		%{name} = %{version}

%description		recursor
This package contains a recursor for the PowerDNS nameserver.

%package		backend-pipe
Summary:		Pipe/coprocess backend for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}

%description		backend-pipe
This package contains the pipe backend for the PowerDNS nameserver. This
allows PowerDNS to retrieve domain info from a process that accepts
questions on stdin and returns answers on stdout. 

%package		backend-mysql
Summary:		MySQL backend for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}
#Requires:		libmysql12 

%description		backend-mysql
This package contains a MySQL backend for the PowerDNS nameserver.

%package		backend-pgsql
Summary:		Generic PostgreSQL backend for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}
#Requires:		libopenssl0.9.7
#Requires:		libpq++4
#Requires:		libpq3
#Requires:		libgcc1
#Requires:		libstdc++5

%description		backend-pgsql
This package contains a generic PostgreSQL backend 
for the PowerDNS nameserver. It has configurable SQL statements.

%package		backend-xdb
Summary:		XDB/tdb/gdb backend for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}
#Requires:		libtdb1

%description		backend-xdb
This package contains a table backend for PowerDNS. Currently includes TDB,
the Trivial Database or Tridgell Database.

%package		backend-ldap
Summary:		LDAP backend for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}
#Requires:		libldap2

%description		backend-ldap
This package contains a LDAP backend for the PowerDNS nameserver.

%package		backend-sqlite
Summary:		SQLite backend for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}

%description		backend-sqlite
This package contains a SQLite backend for the PowerDNS nameserver.

%package		devel
Summary:		Development headers and libraries for %{name}
Group:			System/Servers
Requires:		%{name} = %{version}
Requires:		%{name}-backend-pipe = %{version}
Requires:		%{name}-backend-mysql = %{version}
Requires:		%{name}-backend-pgsql = %{version}
Requires:		%{name}-backend-xdb = %{version}
Requires:		%{name}-backend-ldap = %{version}
Requires:		%{name}-backend-sqlite = %{version}

%description		devel
Development headers and libraries for %{name}

%prep

%setup -q -n pdns-%{version} -a1
%patch0 -p0
%patch1 -p1
%patch2 -p0

%build

%define __libtoolize /bin/true

%serverbuild

%configure2_5x \
    --sysconfdir=%{_sysconfdir}/powerdns \
    --libdir=%{_libdir}/powerdns \
    --with-socketdir=/var/run/powerdns \
    --with-dynmodules="gmysql gpgsql pipe xdb ldap gsqlite" \
    --with-modules="" \
    --with-mysql=%{_prefix} \
    --with-pgsql=%{_prefix} \
    --with-sqlite=%{_prefix} \
    --with-sqlite-includes=%{_includedir} \
    --enable-recursor

# why is this nessesary all of a sudden?
find . -type f -name "Makefile" | xargs perl -pi -e "s|-pthread|-lpthread|g"

%make

# this might work someday..., meanwhile use S1
#pushd pdns/docs
#    make
#popd

%install
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

# don't fiddle with the initscript!
export DONT_GPRINTIFY=1

%makeinstall_std

install -d %{buildroot}/var/run/powerdns

# fix the config
mv %{buildroot}%{_sysconfdir}/powerdns/pdns.conf-dist %{buildroot}%{_sysconfdir}/powerdns/pdns.conf

cat >> %{buildroot}%{_sysconfdir}/powerdns/pdns.conf << EOF
module-dir=%{_libdir}/powerdns
socket-dir=/var/run/powerdns
setuid=powerdns
setgid=powerdns
launch=bind
#recursor=127.0.0.1:5300
EOF

cat >> %{buildroot}%{_sysconfdir}/powerdns/recursor.conf << EOF
soa-minimum-ttl=0
soa-serial-offset=0
aaaa-additional-processing=off
local-port=5300
local-address=127.0.0.1
trace=off
daemon=yes
quiet=on
EOF

chmod 600 %{buildroot}%{_sysconfdir}/powerdns/pdns.conf
chmod 644 %{buildroot}%{_sysconfdir}/powerdns/recursor.conf

# install sysv scripts
install -d %{buildroot}%{_initrddir}
install -m755 pdns/pdns %{buildroot}%{_initrddir}/powerdns

bzcat %{SOURCE2} > %{buildroot}%{_initrddir}/powerdns-recursor
chmod 755 %{buildroot}%{_initrddir}/powerdns-recursor

cat >> README.recursor << EOF

NOTE: This is still experimental...

To enable the recursor for the PowerDNS server issue the command:

echo "recursor=127.0.0.1:5300" >> %{_sysconfdir}/powerdns/pdns.conf

And restart PowerDNS like this:

service powerdns restart

(It's hard to get this plug and play'ish and to please averyone,
especially Mr. Lint...)

-- 
Regards // Oden Eriksson, Deserve-IT.com

EOF


%pre
%_pre_useradd powerdns /var/lib/powerdns /bin/false

%post
%_post_service powerdns

%preun
%_preun_service powerdns

%postun
%_postun_userdel powerdns

%post recursor
%_post_service powerdns-recursor

%preun recursor
%_preun_service powerdns-recursor

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc ChangeLog HACKING INSTALL README TODO WARNING rtfm.powerdns.com
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/powerdns/pdns.conf
%config(noreplace) %attr(0755,root,root) %{_initrddir}/powerdns
%dir %{_sysconfdir}/powerdns
%dir %{_libdir}/powerdns
%dir %attr(0755,powerdns,powerdns) /var/run/powerdns
%{_bindir}/pdns_control
%{_bindir}/xdb-fill
%{_bindir}/zone2sql
%{_bindir}/zone2ldap
%{_sbindir}/pdns_server
%{_mandir}/man8/pdns_control.8*
%{_mandir}/man8/pdns_server.8*
%{_mandir}/man8/zone2sql.8*

%files recursor
%defattr(-,root,root)
%doc rtfm.powerdns.com/recursion.html README.recursor
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/powerdns/recursor.conf
%config(noreplace) %attr(0755,root,root) %{_initrddir}/powerdns-recursor
%{_sbindir}/pdns_recursor

%files backend-pipe
%defattr(-,root,root)
%{_libdir}/powerdns/libpipebackend.so

%files backend-mysql
%defattr(-,root,root)
%{_libdir}/powerdns/libgmysqlbackend.so

%files backend-pgsql
%defattr(-,root,root)
%{_libdir}/powerdns/libgpgsqlbackend.so

%files backend-xdb
%defattr(-,root,root)
%{_libdir}/powerdns/libxdbbackend.so

%files backend-ldap
%defattr(-,root,root)
%{_libdir}/powerdns/libldapbackend.so

%files backend-sqlite
%defattr(-,root,root)
%{_libdir}/powerdns/libgsqlitebackend.so

%files devel
%defattr(-,root,root)
#%{_libdir}/powerdns/*.so
%{_libdir}/powerdns/*.la
%{_libdir}/powerdns/*.a

%changelog
* Thu Dec 18 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.9.13-1mdk
- 2.9.13
- new S1, added P2

* Fri Oct 31 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.9.12-1mdk
- 2.9.12
- sqlite support, new S1, added P1
- drop the static-devel sub package
- fix explicit-lib-dependency & invalid-build-requires
- thanks to Charles A Edwards for reminding me about the libtool stuff

* Sat Aug 23 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.9.11-1mdk
- 2.9.11

* Wed Jul 16 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.9.10-1mdk
- 2.9.10
- rebuilt against new openldap, etc.
- spec file hack to make it build
- new S1
- no linking against sasl is done here, so remove this dependency

* Sun Jun 29 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.9.8-2mdk
- built against new PostgreSQL libs
- use macros
- misc spec file fixes

* Fri May 02 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.9.8-1mdk
- 2.9.8
- new S1
- misc spec file fixes

* Sat Mar 29 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.9.7-3mdk
- fix S2 (run as the powerdns user, thanks bugzilla-mandrake@bkor.dhs.org)
- fix P0 to reflect socketdir location

* Wed Mar 26 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.9.7-2mdk
- fix #3517 (as an optional subpackage)
- fix socketdir

* Sun Mar 23 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.9.7-1mdk
- 2.9.7
- fresh S1

* Tue Mar 11 2003 Marcel Pol <mpol@gmx.net> 2.9.6-3mdk
- conflicts: tmdns

* Mon Mar 10 2003 Marcel Pol <mpol@gmx.net> 2.9.6-2mdk
- buildreq: libgdbm2-devel

* Mon Feb 17 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.9.6-1mdk
- 2.9.6
- added the backend-ldap sub package
- misc spec file fixes
- built against latest requires and buildrequires

* Sat Jan 18 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.9.4-1mdk
- 2.9.4
- added missing stuff in %{_bindir}/
- broke out the modules into separate sub packages, used the
  debian descriptions
- added development sub packages
- misc spec file fixes

* Tue Dec 17 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.9.2-1mdk
- initial cooker contrib (i cross my fingers that it works on first try...)
